/* This file combines all psf gaussian coefficient files into one. */
//gcc -g -static -o comb_gcoef comb_gcoef.c -lm

#include <stdio.h>
#include <math.h>
#include <stdlib.h>
#include <string.h>

struct gcoef{
  float sum;
  float mx;
  float my;
  float phi;
  float lx;
  float ly;
};

main(int argc, char **argv)
{
  struct gcoef *gcoef;
  int i_cnt;
  FILE *f_psfin, *f_psfout;
  unsigned short ii, jj, kk;
  long num_angs;
  char *file_idx[] = {"1","2","4","8"};
  long i, j, k, n;
  char *fname,*fbase;
  long flength;
  long tot_flen = 0;
  int base_len;
  char fpath[512];

  setlinebuf(stdout);
  
  if (argc != 4){
    printf("comb_gcoef gcoef_basename out_psfout num_angs\n\n");
    exit(0);
  }

  fname = argv[1];
  //base_len = strlen(fpath);



  num_angs = atoi(argv[3]);

  f_psfout = fopen(argv[2], "w");
  printf("\n opened psfout file, %s\n",argv[2]);

  gcoef = (struct gcoef *)malloc(num_angs*sizeof(struct gcoef));

  //open all psf files 
  for (i = 0; i < 4; i++){
    //read in i-th psfgcoef file
    sprintf(fpath,"%s%s",fname,file_idx[i]);
    //fpath = strcat(fname,file_idx[i]);
    f_psfin = fopen(fpath, "r");
    if (f_psfin == 0){
      printf("\n couldn't open %d-th psf file, %s\n",i,fpath);
      exit(0);
    }
    
    fseek(f_psfin, 0, SEEK_END);
    flength = ftell(f_psfin);
    tot_flen += flength;
    printf(" filename = %s, ",fpath);
    printf("file length = %d.\n",flength);
    fseek(f_psfin, 0, SEEK_SET);
    
    //loop over psf voxels
    while (i_cnt = fread(&ii, sizeof(unsigned short), 1, f_psfin), i_cnt > 0){
      fread(&jj, sizeof(unsigned short), 1, f_psfin);
      fread(&kk, sizeof(unsigned short), 1, f_psfin);
      fread(gcoef, sizeof(struct gcoef), num_angs, f_psfin);
      ii = ntohs(ii); jj = ntohs(jj); kk = ntohs(kk);
      for (n = 0; n < num_angs; n++){
	*(long *)&gcoef[n].sum = ntohl(*(long *)&gcoef[n].sum);
	*(long *)&gcoef[n].mx = ntohl(*(long *)&gcoef[n].mx);
	*(long *)&gcoef[n].my = ntohl(*(long *)&gcoef[n].my);
	*(long *)&gcoef[n].phi = ntohl(*(long *)&gcoef[n].phi);
	*(long *)&gcoef[n].lx = ntohl(*(long *)&gcoef[n].lx);
	*(long *)&gcoef[n].ly = ntohl(*(long *)&gcoef[n].ly);
      }

      ii = htons(ii); jj = htons(jj); kk = htons(kk);
      for (n = 0; n < num_angs; n++){
	*(long *)&gcoef[n].sum = htonl(*(long *)&gcoef[n].sum);
	*(long *)&gcoef[n].mx = htonl(*(long *)&gcoef[n].mx);
	*(long *)&gcoef[n].my = htonl(*(long *)&gcoef[n].my);
	*(long *)&gcoef[n].phi = htonl(*(long *)&gcoef[n].phi);
	*(long *)&gcoef[n].lx = htonl(*(long *)&gcoef[n].lx);
	*(long *)&gcoef[n].ly = htonl(*(long *)&gcoef[n].ly);
      }
      fwrite(&ii, sizeof(unsigned short), 1, f_psfout);
      fwrite(&jj, sizeof(unsigned short), 1, f_psfout);
      fwrite(&kk, sizeof(unsigned short), 1, f_psfout);
      fwrite(gcoef, sizeof(struct gcoef), num_angs, f_psfout);
    }
    printf(" read over the psf gaussian coefficient file: %s\n",fpath);
    fclose(f_psfin);
  }
  printf("\n total file length should be = %d.\n",tot_flen);

  fclose(f_psfout);
}
