// Function for median filtering the likelihood threshold values returned by sort_like_thresh.c
// Actually, it would probably work for any MxM image.

// jyh, 11/05

#include <stdio.h>
#include <math.h>
#include <stdlib.h>
#include <string.h>

main(int argc, char **argv)
{

  int mdrf, mdrf_sq;
  char *out_file,*in_file,filename[256];
  FILE *fid;
  long int *thresh_mf,*thresh_orig;
  int i,j,k,l,m,n,N;

  setlinebuf(stdout);

  if (argc != 5){
    printf("usage:prog_name thresh_in thresh_out mdrf_dim med_window\n");
    exit(0);
  }

  in_file = argv[1];
  out_file = argv[2];
  mdrf = atoi(argv[3]);
  N = atoi(argv[4]);
  mdrf_sq = mdrf*mdrf;

  thresh_orig = (long int *)malloc(mdrf_sq*sizeof(long int));
  thresh_mf = (long int *)malloc(mdrf_sq*sizeof(long int));
  long int thresh_2d[mdrf+N-1][mdrf+N-1];
  long int temp_vals[N*N];

  fid = fopen(in_file,"r");
  fread(thresh_orig,sizeof(long int),mdrf_sq,fid);
  for (n = 0; n < mdrf_sq; n++) thresh_orig[n] = ntohl(thresh_orig[n]);
  fclose(fid);

  // DO A LITTLE ZERO-PADDING
  for (i = 0; i < mdrf+(N-1); i++){
    for (j = 0; j < mdrf+(N-1); j++){
      thresh_2d[i][j] = 0;
    }
  }
 
  // FILL IN THE ORIGINAL IMAGE
  for (i = 0; i < mdrf; i++){
    for (j = 0; j < mdrf; j++){
      thresh_2d[i+(N-1)/2][j+(N-1)/2] = thresh_orig[i*mdrf+j];
    }
  }

  // USE QUICKSORT TO MEDIAN FILTER
  for (i = (N-1)/2; i < mdrf+(N-1)/2; i++){
    for (j = (N-1)/2; j < mdrf+(N-1)/2; j++){
      for (k = 0; k < N; k++){
	for (l = 0; l < N; l++){
	  temp_vals[N*k+l] = thresh_2d[i+k-(N-1)/2][j+l-(N-1)/2];
	}
      }
      quick_sort_long(temp_vals,0,N*N-1);
      thresh_mf[(i-(N-1)/2)*mdrf+j-(N-1)/2] = temp_vals[(N*N-1)/2];
    }
  }

  // WRITE OUT THE MEDIAN FILTERED IMAGE
  fid = fopen(out_file,"w");
  for (n = 0; n < mdrf_sq; n++) thresh_mf[n] = htonl(thresh_mf[n]);
  fwrite(thresh_mf,sizeof(long int),mdrf_sq,fid);
  fclose(fid);

  free(thresh_orig);free(thresh_mf);

}
