// Function for sorting likelihood threshold values for the purpose of likelihood windowing

// jyh, 11/05

#include <stdio.h>
#include <math.h>
#include <stdlib.h>
#include <string.h>

main(int argc, char **argv)
{

  int mdrf, mdrf_sq;
  char *pos_file,*like_file,*thresh_file,filename[256];
  FILE *fid;
  short int *pos,*pos_temp;
  float *like, *like_temp, *like_large, *thresh;
  int i,j,k,cutoff,n;
  long int count,vect_length;

  setlinebuf(stdout);

  if (argc != 6){
    printf("usage:prog_name pos_file like_file thresh_file mdrf cutoff\n");
    exit(0);
  }

  pos_file = argv[1];
  like_file = argv[2];
  thresh_file = argv[3];
  mdrf = atoi(argv[4]);
  cutoff = atoi(argv[5]);
  mdrf_sq = mdrf*mdrf;

  // SET UP SOME TEMPORARY FILES AND DETERMINE HOW MANY EVENTS THERE ARE TO DEAL WITH
  pos_temp = (short int *)malloc(100000000*sizeof(short int));

  fid = fopen(pos_file,"r");
  vect_length = (long)fread(pos_temp,sizeof(short int),100000000,fid);
  for (n = 0; n < vect_length; n++) pos_temp[n] = ntohs(pos_temp[n]);
  fclose(fid);

  // READ IN THE POS AND LIKE VALUES
  pos = (short int *)malloc(vect_length*sizeof(short int));
  like = (float *)malloc(vect_length*sizeof(float));

  for (i = 0; i < vect_length; i++) pos[i] = pos_temp[i];
  free(pos_temp);

  fid = fopen(like_file,"r");
  fread(like,sizeof(float),vect_length,fid);
  for (n = 0; n < vect_length; n++) *(long *)&like[n] = ntohl(*(long *)&like[n]);
  fclose(fid);

  thresh = (float *)malloc(mdrf_sq*sizeof(float));
  thresh[0] = 0.0;

  // USE A QUICKSORT ALGORITHM TO SORT THE LIKELIHOOD VALUES FOR EACH PIXEL AND SET A THRESHOLD
  for (i = 1; i < mdrf_sq; i++){
    like_large = (float *)malloc(10000000*sizeof(float));    
    count = 0;
    for (j = 0; j < vect_length; j++){
      if (pos[j] == i){
			 like_large[count] = like[j];
			 count++;
      }
    }
    if (count > 0){
      like_temp = (float *)malloc(count*sizeof(float));
		for (j = 0; j < count; j++) like_temp[j] = like_large[j];
      quick_sort_float(like_temp,0,count-1);
		if (count > cutoff) thresh[i] = like_temp[count-cutoff];
      else thresh[i] = like_temp[count-1];
      free(like_temp);
    }
    else thresh[i] = 0.0;
    free(like_large);
    if (i%500 == 0) printf("%d\n",i);
  }

  fid = fopen(thresh_file,"w");
  for (n = 0; n < mdrf_sq; n++) *(long *)&thresh[n] = htonl(*(long *)&thresh[n]);
  fwrite(thresh,sizeof(float),mdrf_sq,fid);
  fclose(fid);
  free(thresh);free(pos);free(like);
}
