#!/usr/bin/perl -w

use strict;

if (@ARGV != 7) {
    print <<'USAGE';
Usage:
  ProcessPSF <PSFFile> <Camera> <Dimension> <Num_Coords> <Fudge> <MDRFDirectory> <OutputDirectory>

ProcessPSF takes a raw PSF and prepares it reconstruction.
For a more detailed description, please see the documentation.

USAGE
exit;
}

my $PSFFile = shift;
my $Cam = shift;
my $Dim = shift;
my $Coords = shift;
my $Fudge = shift;
my $MDRFDir = shift;
$MDRFDir =~ s|/$||g;
my $OutDir = shift;
$OutDir =~ s|/$||g;

`mkdir $OutDir` unless -d $OutDir;

my $tmpfile = "$OutDir/"."CrunchFile_0"."$Cam";

if (-f "$tmpfile"){
    print "Crunched PSF file : $tmpfile exists.\n";
    print "The crunching of the raw PSF file will be skipped.\n";
} else {
    print "Crunching the raw PSF file...\n";
    my $cmd = "psf_LW_cruncher $MDRFDir/MeanFile_0$Cam $MDRFDir/Log_Fact $MDRFDir/FiltThresholds_0$Cam 8 $PSFFile $OutDir/CrunchFile_0$Cam $Coords $Dim $Fudge >/dev/null";
    `$cmd`;
}

print "Sorting the crunched PSF file...\n";
`PSF_sort $OutDir/ CrunchFile_0$Cam $Cam $Coords $Dim >/dev/null`;

